Gecode::Int::Linear::Lin< Val, P, N, pc > Class Template Reference

Base-class for n-ary linear propagators. More...

`#include <linear.hh>`

## Public Member Functions

virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (defined as low linear).
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)=0
| Propagation function.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
Public Member Functions inherited from Gecode::Actor
virtual Actor * | copy (Space &home)=0
| Create copy.
virtual | ~Actor (void)
| To avoid warnings.

## Protected Member Functions

| Lin (Space &home, Lin< Val, P, N, pc > &p)
| Constructor for cloning p.
| Lin (Home home, ViewArray< P > &x, ViewArray< N > &y, Val c)
| Constructor for creation.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

ViewArray< P > | x
| Array of positive views.
ViewArray< N > | y
| Array of negative views.
Val | c
| Constant value.

## Related Symbols

(Note that these are not member symbols.)
template<class Val, class View>
void | bounds_p (ModEventDelta med, ViewArray< View > &x, Val &c, Val &sl, Val &su)
| Compute bounds information for positive views.
template<class Val, class View>
void | bounds_n (ModEventDelta med, ViewArray< View > &y, Val &c, Val &sl, Val &su)
| Compute bounds information for negative views.

## Additional Inherited Members

static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Detailed Description

template<class Val, class P, class N, PropCond pc>
class Gecode::Int::Linear::Lin< Val, P, N, pc >

Base-class for n-ary linear propagators.

The type Val can be either `long` long int or `int`, defining the numerical precision during propagation. Positive views are of type P whereas negative views are of type N.

The propagation condition pc refers to all views.

Definition at line 497 of file linear.hh.

## Constructor & Destructor Documentation

## Lin() [1/2]

template<class Val, class P, class N, PropCond pc>

Gecode::Int::Linear::Lin< Val, P, N, pc >::Lin | ( | Space & | home,
|  | Lin< Val, P, N, pc > & | p )

inline protected

Constructor for cloning p.

Definition at line 69 of file int-nary.hpp.

## Lin() [2/2]

template<class Val, class P, class N, PropCond pc>

Gecode::Int::Linear::Lin< Val, P, N, pc >::Lin | ( | Home | home,
|  | ViewArray< P > & | x,
|  | ViewArray< N > & | y,
|  | Val | c )

inline protected

Constructor for creation.

Definition at line 61 of file int-nary.hpp.

## Member Function Documentation

## cost()

template<class Val, class P, class N, PropCond pc>

PropCost Gecode::Int::Linear::Lin< Val, P, N, pc >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function (defined as low linear).

Implements Gecode::Propagator.

Reimplemented in Gecode::Int::Linear::DomEq< Val, View >.

Definition at line 77 of file int-nary.hpp.

## reschedule()

template<class Val, class P, class N, PropCond pc>

void Gecode::Int::Linear::Lin< Val, P, N, pc >::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Implements Gecode::Propagator.

Reimplemented in Gecode::Int::Linear::ReLin< Val, P, N, pc, Ctrl >, Gecode::Int::Linear::ReLin< Val, P, N, PC_INT_BND, BoolView >, and Gecode::Int::Linear::ReLin< Val, P, N, PC_INT_BND, Ctrl >.

Definition at line 83 of file int-nary.hpp.

## dispose()

template<class Val, class P, class N, PropCond pc>

size_t Gecode::Int::Linear::Lin< Val, P, N, pc >::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::Actor.

Reimplemented in Gecode::Int::Linear::ReLin< Val, P, N, pc, Ctrl >, Gecode::Int::Linear::ReLin< Val, P, N, PC_INT_BND, BoolView >, and Gecode::Int::Linear::ReLin< Val, P, N, PC_INT_BND, Ctrl >.

Definition at line 90 of file int-nary.hpp.

## Friends And Related Symbol Documentation

## bounds_p()

template<class Val, class View>

void bounds_p | ( | ModEventDelta | med,
|  | ViewArray< View > & | x,
|  | Val & | c,
|  | Val & | sl,
|  | Val & | su )

related

Compute bounds information for positive views.

Definition at line 140 of file int-nary.hpp.

## bounds_n()

template<class Val, class View>

void bounds_n | ( | ModEventDelta | med,
|  | ViewArray< View > & | y,
|  | Val & | c,
|  | Val & | sl,
|  | Val & | su )

related

Compute bounds information for negative views.

Definition at line 161 of file int-nary.hpp.

## Member Data Documentation

## x

template<class Val, class P, class N, PropCond pc>

ViewArray<P> Gecode::Int::Linear::Lin< Val, P, N, pc >::x

protected

Array of positive views.

Definition at line 500 of file linear.hh.

## y

template<class Val, class P, class N, PropCond pc>

ViewArray<N> Gecode::Int::Linear::Lin< Val, P, N, pc >::y

protected

Array of negative views.

Definition at line 502 of file linear.hh.

## c

template<class Val, class P, class N, PropCond pc>

Val Gecode::Int::Linear::Lin< Val, P, N, pc >::c

protected

Constant value.

Definition at line 504 of file linear.hh.

The documentation for this class was generated from the following files:

- gecode/int/linear.hh
- gecode/int/linear/int-nary.hpp